-- File automatically generated by KpnMapper
-- For control_if

library ieee;
use ieee.std_logic_1164.all;

--
-- ============================================
-- = PAMETER CONTROLLER                       =
-- ============================================
-- 

entity control_if is
	generic (
		RESET_HIGH       : natural := 1;
		QUANT            : natural := 32
	);
	port (
		RST              : in  std_logic;
		CLK              : in  std_logic;
		SYNC_NUM         : in  std_logic_vector(9 downto 0);
		PARAM_LD         : out std_logic;
		PARAM_DT         : out std_logic_vector((QUANT+10-1) downto 0);
		--
		PARAM_FIFO_FULL  : in std_logic;
		--
		PARAMETERS_IN_LD : in std_logic;
		PARAMETERS_IN    : in  std_logic_vector((QUANT-1) downto 0)

	);
end control_if;

architecture fsl_test of control_if is

	signal sl_RST        : std_logic;
	signal sl_load       : std_logic;
	signal sl_data       : std_logic_vector((QUANT-1) downto 0);
	signal sl_data_r     : std_logic_vector((QUANT-1) downto 0);
	signal sl_sync_num   : std_logic_vector(9 downto 0);
	signal sl_sync_num_r : std_logic_vector(9 downto 0);

	type state_type is (s_idle, s_param, s_update, s_release);
	signal state : state_type;

begin

	sl_RST <= RST when (RESET_HIGH=1) else not RST;

	process(CLK, sl_data_r)
	begin
		 if (rising_edge(CLK)) then
			if (sl_RST='1') then
				sl_load <= '0';
				sl_data <= (others=>'0');
				sl_data_r <= (others=>'0');
				sl_sync_num <= (others=>'0');
				sl_sync_num_r <= (others=>'0');
			else
				sl_data <= sl_data_r;
				sl_data_r <= PARAMETERS_IN((QUANT-1) downto 0);
				sl_sync_num <= sl_sync_num_r;
				sl_sync_num_r <= SYNC_NUM;
				case (state) is
					when s_idle   =>
						if(sl_data_r /= sl_data) then
							state <= s_param;
						end if;
					when s_param =>
						if(sl_sync_num /= sl_sync_num_r) then
							state <= s_update;
						end if;
					when s_update =>
						if(PARAM_FIFO_FULL = '0') then
							sl_load <= '1';
							state <= s_release;
						end if;
					when s_release =>
						sl_load <= '0';
						state <= s_idle;
					when others =>
						state <= s_idle;
				end case;
			end if;
		end if;
	end process;

	PARAM_LD    <= sl_load;
	PARAM_DT    <= sl_sync_num & sl_data;

end architecture fsl_test;
