-- File automatically generated by KpnMapper

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library compaandesign_com_common_hwnode_1_lib;
use compaandesign_com_common_hwnode_1_lib.all;
library compaandesign_com_common_common_1_lib;
use compaandesign_com_common_common_1_lib.hw_node_pkg.all;

entity pipeline2rtl_EVAL_LOGIC_RD_hwn_nd_3 is
   generic (
      N_IN_PORTS    : natural := 1;
      WRAP          : boolean := true;
      N_CNTRS       : natural := 1; 
      QUANT         : natural := 32;
      CNTR_STEP     : t_counter_step  := ( 0=> 1, 1=> 1, 2=>1, others=> 1 );
      CNTR_WIDTH    : t_counter_width := ( 0=>10, 1=>10, 2=>9, others=>10 )
   );
   port (
      RST           : in  std_logic;
      CLK           : in  std_logic;
      PARAMETERS    : in  std_logic_vector(10 downto 0); 
      REG_CNTRS     : out std_logic_vector(N_CNTRS*QUANT-1 downto 0);
      READ_EN       : out std_logic_vector(0 downto 0);
      READ_ST       : in  std_logic_vector(0 downto 0);
      HALT          : in  std_logic;
      FIRE          : out std_logic;
      DONE          : out std_logic;
      STOP          : out std_logic;
      SOF           : out std_logic;
      CONTROL       : out std_logic_vector(N_IN_PORTS-1 downto 0);
      OBTAIN        : out std_logic_vector(N_IN_PORTS-1 downto 0);
      RELEASE       : out std_logic_vector(N_IN_PORTS-1 downto 0)
   );
end pipeline2rtl_EVAL_LOGIC_RD_hwn_nd_3;

architecture RTL of pipeline2rtl_EVAL_LOGIC_RD_hwn_nd_3 is
   -- 
   component counter is 
      generic( 
         C_STEP    : natural := 10; 
         C_WIDTH   : natural := 10 
      ); 
      port ( 
         RST       : in  std_logic; 
         CLK       : in  std_logic; 
         ENABLE    : in  std_logic; 
         LOWER_BND : in  std_logic_vector(C_WIDTH-1 downto 0); 
         UPPER_BND : in  std_logic_vector(C_WIDTH-1 downto 0); 
         ITERATOR  : out std_logic_vector(C_WIDTH-1 downto 0); 
         REG_CNTR  : out std_logic_vector(C_WIDTH-1 downto 0); 
         DONE      : out std_logic 
      ); 
   end component; 
   -- 
   component it_mod is 
   generic( 
      C_MOD     : natural := 10; 
      C_WIDTH   : natural := 10; 
      C_INIT    : natural :=  1; 
      C_STEP    : natural :=  1  
   ); 
   port ( 
      RST       : in  std_logic; 
      CLK       : in  std_logic; 
      LOAD      : in  std_logic; 
      ENABLE    : in  std_logic; 
      MODULE    : out std_logic_vector(C_WIDTH-1 downto 0) 
   ); 
   end component; 
   -- 
   --  
   -- Parameter related signals 
   alias  par_SPLIT_X : std_logic_vector(10 downto 0) is PARAMETERS(10 downto 0); 
   signal sl_SPLIT_X : integer range 0 to 805; 
   -- 
   -- Iterator (counter) related signals 
   signal sl_low_y, sl_high_y : integer;
   signal sl_low_x, sl_high_x : integer;
   signal sl_loop_y, sl_loop_y_rg : integer;
   signal sl_loop_x, sl_loop_x_rg : integer;
   signal sl_lower_bnd, sl_upper_bnd : std_logic_vector(N_CNTRS*QUANT-1 downto 0); 
   signal sl_iterators, sl_reg_cntrs : std_logic_vector(N_CNTRS*QUANT-1 downto 0); 
   -- 
   signal sl_cntr_en  : std_logic_vector(N_CNTRS   downto 0); 
   signal sl_done     : std_logic_vector(N_CNTRS-1 downto 0); 
   signal sl_done_all : std_logic; 
   signal sl_load     : std_logic_vector(N_CNTRS-1 downto 0); 
   signal sl_stop     : std_logic; 
   signal sl_fire     : std_logic; 
   signal sl_sof      : std_logic; 
   signal sl_eof      : std_logic; 

   -- alias signals 
   alias update_y : std_logic is sl_cntr_en(1);
   alias update_x : std_logic is sl_cntr_en(0);
   alias load_y : std_logic is sl_load(1);
   alias load_x : std_logic is sl_load(0);

   -- Trigger signals 
   signal sl_trigger_y : std_logic;
   signal sl_trigger_x : std_logic;

   -- Special Control signal
   signal sl_CONTROL       : std_logic_vector(N_IN_PORTS-1 downto 0);
   signal sl_no_request    : std_logic;
   -- 
   -- Multirate related signals
   signal sl_mr_en    : std_logic_vector(0 downto 0); 
   signal sl_mr_done  : std_logic_vector(0 downto 0); 
   signal sl_mr_lock  : std_logic_vector(0 downto 0); 
   signal sl_enables  : std_logic_vector(0 downto 0); 
   signal sl_enable   : std_logic; 
   signal ENABLE      : std_logic; 
   -- Function input parameter "in_0", multirate=1 
   constant sl_mr_lbnd_0 : std_logic_vector(0 downto 0) := STD_LOGIC_VECTOR(TO_UNSIGNED(0,1)); 
   constant sl_mr_ubnd_0 : std_logic_vector(0 downto 0) := STD_LOGIC_VECTOR(TO_UNSIGNED(0,1)); 

   signal e0, e1, e2, e3 : boolean;

   signal sl_obtain0  : std_logic;
   signal sl_release0 : std_logic;

   -- define control variables 

   type state_type is (s_idle, s_halt, s_count, s_release);
   signal state : state_type;
   signal halt_cnt : integer;
   signal sl_halt : std_logic;

   signal sl_cnt_rst : std_logic;
   signal cnt_rst : std_logic;

begin

   -- =============================================
   -- =             MOD Functions                  
   -- =============================================
   -- END of MOD definitions 
   --  
   -- Parameter related signal assignments 

   STM_HALT : process(CLK)
   begin
      if rising_edge(CLK) then
         if( RST='1' ) then
            state <= s_idle;
            halt_cnt <= 0;
            sl_cnt_rst <= '0';
         else
            case (state) is
               when s_idle =>
                  if(sl_eof = '1') then
                     state <= s_halt;
                     halt_cnt <= 0;
                     sl_cnt_rst <= '1';
                  end if;
               when s_halt =>
                  sl_cnt_rst <= '0';
                  if halt_cnt < 5 then
                     halt_cnt <= halt_cnt + 1;
                  else
                     state <= s_idle;
  	             end if;
  	          when others =>
  	             state <= s_idle;
            end case;
         end if;
      end if;
   end process;

   sl_halt <= '1' when sl_eof = '1' or state = s_halt else '0';

	sl_SPLIT_X <= TO_INTEGER(SIGNED(par_SPLIT_X));

   sl_loop_y    <= TO_INTEGER(SIGNED(sl_iterators(CNTR_WIDTH(1)+1*QUANT-1 downto 1*QUANT)));
   sl_loop_y_rg <= TO_INTEGER(SIGNED(sl_reg_cntrs(CNTR_WIDTH(1)+1*QUANT-1 downto 1*QUANT)));
   sl_loop_x    <= TO_INTEGER(SIGNED(sl_iterators(CNTR_WIDTH(0)+0*QUANT-1 downto 0*QUANT)));
   sl_loop_x_rg <= TO_INTEGER(SIGNED(sl_reg_cntrs(CNTR_WIDTH(0)+0*QUANT-1 downto 0*QUANT)));

   -- Const bounds for-loops 
   sl_low_y  <= 0;
   sl_high_y <= 805;
   sl_low_x  <= 0;
   sl_high_x <= 805;


   sl_lower_bnd(2*QUANT-1 downto 1*QUANT) <= STD_LOGIC_VECTOR(TO_UNSIGNED(sl_low_y,QUANT));
   sl_lower_bnd(1*QUANT-1 downto 0*QUANT) <= STD_LOGIC_VECTOR(TO_UNSIGNED(sl_low_x,QUANT));

   sl_upper_bnd(2*QUANT-1 downto 1*QUANT) <= STD_LOGIC_VECTOR(TO_UNSIGNED(sl_high_y,QUANT));
   sl_upper_bnd(1*QUANT-1 downto 0*QUANT) <= STD_LOGIC_VECTOR(TO_UNSIGNED(sl_high_x,QUANT));
   -- Special definitions 

   -- Entity and control variables
   -- Release matrix expressions
   e0 <= sl_loop_y_rg>=0;
   e1 <= -sl_loop_y_rg + 805>=0;
   e2 <= sl_loop_x_rg>=0;
   e3 <= -sl_loop_x_rg + 805>=0;

   sl_fire <= ('1');

   -- Convert FIFO Read Port ND_3IP_1 Argument in_1 : ED_1 : 0 of type IOMM
   sl_obtain0 <= ('1');  -- set obtain/release to const value; not used
   sl_release0 <= ('1');

   sl_CONTROL(0) <= sl_fire and b2std((e0 and e1 and e2 and e3));
   OBTAIN(0) <= sl_obtain0;
   RELEASE(0) <= sl_release0;

   FIRE <= sl_fire;

   cnt_rst <= sl_cnt_rst or RST;

   -- 
   -- =============================================
   -- =             Multirate                      
   -- =============================================
   -- Function input parameter "in_0", multirate=1 
   CNTR_MR0 : counter 
      generic map ( 
         C_STEP    => 1,
         C_WIDTH   => 1
      )
      port map (
         CLK       => CLK,
         RST       => RST,
         ENABLE    => sl_mr_en(0),
         LOWER_BND => sl_mr_lbnd_0,
         UPPER_BND => sl_mr_ubnd_0,
         ITERATOR  => open,
         REG_CNTR  => open,
         DONE      => sl_mr_done(0)
      );
   -- 
   READ_EN    <= (others=>'1') when ((sl_stop='0') and (sl_fire='1')) else (others=>'0');  
   sl_mr_en   <= READ_ST; 
   sl_enables <= sl_mr_lock or (sl_mr_done and sl_mr_en); 
   sl_enable  <= '1' when (sl_enables=(sl_enables'range=>'1')) else '0'; -- and_reduce 
   ENABLE     <=  sl_enable or (not sl_fire);
   -- 
   LOCK_PRCS: process(CLK) 
   begin 
       if rising_edge(CLK) then 
           if( RST = '1' ) then 
               sl_mr_lock <= (others=>'0'); 
           else  
               if (ENABLE='1') then 
                   sl_mr_lock <= (others=>'0'); 
               else 
                   for i in 0 to 0 loop 
                       if (sl_mr_done(i)='1' and sl_mr_en(i)='1') then 
                           sl_mr_lock(i) <= '1'; 
                       end if; 
                   end loop; 
               end if; 
           end if; 
       end if; 
   end process; 
   -- END of Multirate definitions 
   -- 
   -- =============================================
   -- =             Iterators                      
   -- =============================================
   GEN_CNTR_RD : for i in 0 to N_CNTRS-1 generate
   	CNTR_RD : counter
   	generic map ( 
   		C_STEP    => CNTR_STEP(i),
   		C_WIDTH   => CNTR_WIDTH(i)
   	)
  	 port map (
   		CLK       => CLK,
   		RST       => cnt_rst,
   		ENABLE    => sl_cntr_en(i),
   		LOWER_BND => sl_lower_bnd(i*QUANT+CNTR_WIDTH(i)-1 downto i*QUANT),
   		UPPER_BND => sl_upper_bnd(i*QUANT+CNTR_WIDTH(i)-1 downto i*QUANT),
   		ITERATOR  => sl_iterators(i*QUANT+CNTR_WIDTH(i)-1 downto i*QUANT),
   		REG_CNTR  => sl_reg_cntrs(i*QUANT+CNTR_WIDTH(i)-1 downto i*QUANT),
   		DONE      => sl_done(i)
   	);
   end generate;
   --
   DONE_PRCS: process(CLK)
   begin
   	if rising_edge(CLK) then
          if( RST = '1' ) then
   		    sl_stop     <= '0';
   		    sl_done_all <= '0';
   		    sl_sof      <= '1';
   	    else 
   		    if (sl_cntr_en(N_CNTRS)='1' and (WRAP=false or sl_halt='1')) then
   			    sl_stop <= '1';
   		    elsif (WRAP=true and sl_halt='0') then
   			    sl_stop <= '0';
   		    end if;
   		    if (sl_stop='0') then
   			    sl_done_all <= sl_cntr_en(N_CNTRS);
   		    end if;
   		    if (ENABLE='1') then
   			    sl_sof <= sl_eof;
   		    end if;
   	    end if;
   	end if;
   end process;
   --
   sl_no_request <= '0' when (sl_CONTROL=(sl_CONTROL'range =>'0') and sl_halt='0') else '1';
   CONTROL <= sl_CONTROL;
   --
   REG_CNTRS <= sl_reg_cntrs; 
   DONE <= sl_done_all;     -- '1' in the clock cycle when the counters roll over (from the last point in the space to the firts pont)
   STOP <= sl_stop;         -- '1' = The couter stoped after the end of the itteration space. 
   sl_cntr_en(0) <=  '0' when (sl_stop='1') else
                     '1' when (((sl_fire='0') or (ENABLE='1') or (sl_no_request='0'))) else '0';
   sl_cntr_en(N_CNTRS  downto 1) <= sl_cntr_en(N_CNTRS-1  downto 0) and sl_done(N_CNTRS-1  downto 0);
   sl_eof <= sl_cntr_en(N_CNTRS);   -- End-of-frame
   SOF    <= sl_eof;                -- Start-of-frame
   --
end RTL;
