-- HWN Entity File automatically generated by KpnMapper
-- Top level file for a Hardware Accelerator
-- Function "compaan_outlinedproc7"

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library compaandesign_com_common_common_1_lib;
use compaandesign_com_common_common_1_lib.hw_node_pkg.all;

library compaandesign_com_common_hwnode_1_lib;
use compaandesign_com_common_hwnode_1_lib.all;

entity pipeline2rtl_hwn_nd_6 is
   generic (
      STIM_DIR   : string  := "bla";
      RESET_HIGH : natural := 1;
      PAR_WIDTH  : natural := 16;
      QUANT      : natural := 32;
      C_SYNC_IN : NATURAL := 1;
      C_SYNC_OUT : NATURAL := 1;
      WRAP       : boolean := true
   );
   port (

      -- Dataflow input interfaces
      -- ED_4 : in_0
      ND_6IP_4_Rd    : out std_logic;
      ND_6IP_4_Din   : in  std_logic_vector(31 downto 0);
      ND_6IP_4_Exist : in  std_logic; 
      ND_6IP_4_CLK   : out std_logic;
      ND_6IP_4_CTRL  : in  std_logic;

      -- Dataflow output interfaces
      -- ED_7 : out_0
      ND_6OP_1_Wr   : out std_logic;
      ND_6OP_1_Dout : out std_logic_vector(31 downto 0);
      ND_6OP_1_Full : in  std_logic;
      ND_6OP_1_CLK  : out std_logic;
      ND_6OP_1_CTRL : out std_logic;

      PARAM_DT : in  std_logic_vector(PAR_WIDTH+10-1 downto 0);
      PARAM_LD : in  std_logic;
      ND_6_PARAM_FIFO_FULL : out  std_logic;
      ND_6_SYNC_NUM : out std_logic_vector(9 downto 0);

      RST      : in  std_logic;
      CLK      : in  std_logic;
      STOP     : out std_logic;
      ERROR    : out std_logic;
      BLOCK_RD : out std_logic
   );
end pipeline2rtl_hwn_nd_6;

architecture RTL of pipeline2rtl_hwn_nd_6 is
   --
   -- ====================================
   -- =     Constants declaration        =
   -- ====================================
   -- Setting the parameters of the HW Node
   constant c_IN_PORTS     : natural := 1; -- number of input ports of a HW node
   constant c_OUT_PORTS    : natural := 1; -- number of output ports of a HW node
   constant c_IN_FUNC_VAR  : natural := 1; -- number of input ports of a HW IP
   constant c_OUT_FUNC_VAR : natural := 1; -- number of output ports of a HW IP
   constant c_COUNTERS     : natural := 2; -- number of iterators
   -- ===========================================
   -- = Iterators run from Inner to Outer loop  =
   -- ===========================================
   constant c_CNTR_QUANT   : natural := 11;
   constant c_CNTR_STEPS   : t_counter_step  := ( 0=>1, 1=>1, others=>1 );
   constant c_CNTR_WIDTHS  : t_counter_width := ( 0=>11, 1=>11, others=>10 );
   constant c_STAGES       : natural := 1; -- number of pipeline stages or delay
   constant c_IP_RESET     : natural := 1; -- active level of the HW IP reset signal
   constant c_WRAP         : boolean := true; -- Operation mode: Single_Shot (false) or Continuous (true)
   constant c_PAR_NUMBER   : natural := 1; -- number of global parameters
   constant c_N_PAR        : natural := 1; -- indicates if parameters are used (1) or not (0)
   constant c_PAR_BITWIDTH : natural := 11; -- aggregate bitwidth of the parameter vector
   constant c_PAR_VECTOR   : t_par_vector:= ( -- (Lower Bound, Upper Bound, Default Value, Bitwidth)
       (2,805,2,11),   -- parameter SPLIT_X
       (0,0,0,0), (0,0,0,0)    -- two dummy elements
   );
   --
   -- ====================================
   -- =     Components declaration       =
   -- ====================================
   component pipeline2rtl_EVAL_LOGIC_RD_hwn_nd_6 is
      generic (
         N_IN_PORTS    : natural := 1;
         WRAP          : boolean := true;
         N_CNTRS       : natural := 1; 
         QUANT         : natural := 32;
         CNTR_STEP     : t_counter_step  := ( 0=> 1, 1=> 1, 2=>1, others=> 1 );
         CNTR_WIDTH    : t_counter_width := ( 0=>10, 1=>10, 2=>9, others=>10 )
      );
      port (
         RST           : in  std_logic;
         CLK           : in  std_logic;
         PARAMETERS    : in  std_logic_vector(10 downto 0); 
         REG_CNTRS     : out std_logic_vector(N_CNTRS*QUANT-1 downto 0); 
         READ_EN       : out std_logic_vector(c_IN_FUNC_VAR-1 downto 0);
         READ_ST       : in  std_logic_vector(c_IN_FUNC_VAR-1 downto 0);
         HALT          : in  std_logic;
         FIRE          : out std_logic;
         DONE          : out std_logic;
         STOP          : out std_logic;
         SOF           : out std_logic;
         CONTROL       : out std_logic_vector(N_IN_PORTS-1 downto 0);
         OBTAIN        : out std_logic_vector(N_IN_PORTS-1 downto 0);
         RELEASE       : out std_logic_vector(N_IN_PORTS-1 downto 0)
      );
   end component;

   component READ_MUX is
      generic (
         N_PORTS    : natural := 1;
         PORT_WIDTH : natural := 32  
      );
      port(
         IN_PORTS   : in  std_logic_vector(N_PORTS*PORT_WIDTH-1 downto 0);
         EXISTS     : in  std_logic_vector(N_PORTS-1 downto 0);
         READS      : out std_logic_vector(N_PORTS-1 downto 0);
         SOFS       : in  std_logic_vector(N_PORTS-1 downto 0);

         OUT_PORT   : out std_logic_vector(PORT_WIDTH-1 downto 0);
         EXIST      : out std_logic;
         READ       : in  std_logic;
         SOF        : in  std_logic;

         READ_EN    : in  std_logic;
         READ_ST    : out std_logic;
         CONTROL    : in  std_logic_vector(N_PORTS-1 downto 0);
         OBTAIN     : in  std_logic_vector(N_PORTS-1 downto 0);
         RELEASE    : in  std_logic_vector(N_PORTS-1 downto 0)
      );
   end component;

   component pipeline2rtl_EVAL_LOGIC_WR_hwn_nd_6 is
      generic ( 
         N_OUT_PORTS   : natural := 1;
         WRAP          : boolean := true;
         N_CNTRS       : natural := 1; 
         QUANT         : natural := 32;
         CNTR_STEP     : t_counter_step  := ( 0=> 1, 1=> 1, 2=>1, others=> 1 );
         CNTR_WIDTH    : t_counter_width := ( 0=>10, 1=>10, 2=>9, others=>10 )
      );
      port (
         RST           : in  std_logic;
         CLK           : in  std_logic;
         PARAMETERS    : in  std_logic_vector(10 downto 0); 
         WRITE_EN      : out std_logic_vector(c_OUT_FUNC_VAR-1 downto 0);
         WRITE_ST      : in  std_logic_vector(c_OUT_FUNC_VAR-1 downto 0);
         HALT          : in  std_logic;
         FIRE          : out std_logic;
         DONE          : out std_logic;
         STOP          : out std_logic;
         SOF           : out std_logic;
         CONTROL       : out std_logic_vector(N_OUT_PORTS-1 downto 0)
      );
   end component;

   component WRITE_DEMUX is
      generic (
         N_PORTS : natural := 1
      );
      port(
         WRITES   : out std_logic_vector(N_PORTS-1 downto 0);
         WRITE    : in  std_logic;

         FULLS    : in  std_logic_vector(N_PORTS-1 downto 0);
         FULL     : out std_logic;

         WRITE_EN : in  std_logic;
         WRITE_ST : out std_logic;
         CONTROL  : in  std_logic_vector(N_PORTS-1 downto 0)
      );
   end component;

   component pipeline2rtl_EXECUTION_UNIT_hwn_nd_6 is
      generic (
         N_INPORTS  : natural := 1;
         N_OUTPORTS : natural := 1;
         IP_RESET   : natural := 1;
         QUANT      : natural := 32;
         STIM_DIR   : string  := "bla";
         c_STAGES   : natural := 1;
         N_CNTRS    : natural := 1;
         CNTR_QUANT : natural := 32;
         CNTR_WIDTH : t_counter_width := ( 0=>10, 1=>10, 2=>9, others=>10 ) 
      );
      port (
         RST        : in  std_logic;
         CLK        : in  std_logic;

         -- Iterators
         REG_CNTRS_RD : in  std_logic_vector(N_CNTRS*CNTR_QUANT -1 downto 0);
         -- Func. Input parameters
         IN_PORT_0 : in  std_logic_vector(31 downto 0); -- tmp1
         READ       : out std_logic_vector(N_INPORTS-1 downto 0);
         EXIST      : in  std_logic_vector(N_INPORTS-1 downto 0);
         -- Func. Output parameters
         OUT_PORT_0 : out std_logic_vector(31 downto 0); -- tmp0
         WRITE      : out std_logic_vector(N_OUTPORTS-1 downto 0);
         FULL       : in  std_logic_vector(N_OUTPORTS-1 downto 0);
         --
         STOP_RD    : in  std_logic;
         STOP_WR    : in  std_logic;
         ERROR      : out std_logic
      );
   end component;

   component PARAMETERS is 
      generic (
         PAR_WIDTH    : natural:=16;
         PAR_BITWIDTH : natural:=1;
         PAR_VECTOR   : t_par_vector;
         N_PAR        : natural:=0
      );
      port (  
         RST        : in  std_logic;
         CLK        : in  std_logic;
         FIFO_FULL  : out std_logic;
         HALT_RD    : out std_logic;
         HALT_WR    : out std_logic;
         SOF_RD     : in  std_logic;
         SOF_WR     : in  std_logic;
         SYNC_NUM   : out std_logic_vector(9 downto 0);

         PARAM_DT   : in  std_logic_vector(PAR_WIDTH+10-1 downto 0);
         PARAM_LD   : in  std_logic;

         PARAMETERS_RD : out std_logic_vector(10 downto 0);
         PARAMETERS_WR : out std_logic_vector(10 downto 0)
      );
   end component;

   --
   -- ====================================
   -- =       Signals declaration        =
   -- ====================================
   -- 
   -- HW Node Input Ports
   signal sl_IN_PORTS_0   : std_logic_vector(1*32-1 downto 0); -- tmp1
   signal sl_EXISTS       : std_logic_vector(c_IN_PORTS-1 downto 0);
   signal sl_READS        : std_logic_vector(c_IN_PORTS-1 downto 0);
   signal sl_CTRLS        : std_logic_vector(c_IN_PORTS-1 downto 0);
   signal sl_control_rd   : std_logic_vector(c_IN_PORTS-1 downto 0);
   signal sl_obtain_rd    : std_logic_vector(c_IN_PORTS-1 downto 0);
   signal sl_release_rd   : std_logic_vector(c_IN_PORTS-1 downto 0);
   -- 
   -- Func. Input parameters
   signal sl_in_port_0    : std_logic_vector(31 downto 0); -- tmp1
   signal sl_exist        : std_logic_vector(c_IN_FUNC_VAR-1 downto 0);
   signal sl_read         : std_logic_vector(c_IN_FUNC_VAR-1 downto 0);
   signal sl_read_en      : std_logic_vector(c_IN_FUNC_VAR-1 downto 0);
   signal sl_read_st      : std_logic_vector(c_IN_FUNC_VAR-1 downto 0);
   -- 
   signal sl_REG_CNTRS_RD : std_logic_vector(c_COUNTERS*c_CNTR_QUANT-1 downto 0);
   -- 
   -- HW Node Output Ports
   signal sl_WRITES       : std_logic_vector(c_OUT_PORTS-1 downto 0);
   signal sl_FULLS        : std_logic_vector(c_OUT_PORTS-1 downto 0);
   signal sl_control_wr   : std_logic_vector(c_OUT_PORTS-1 downto 0);
   signal sl_lortnoc_wr   : std_logic_vector(c_OUT_PORTS-1 downto 0);
   -- 
   -- Func. Output parameters
   signal sl_out_port_0   : std_logic_vector(31 downto 0); -- tmp0
   signal sl_full         : std_logic_vector(c_OUT_FUNC_VAR-1 downto 0);
   signal sl_write        : std_logic_vector(c_OUT_FUNC_VAR-1 downto 0);
   signal sl_write_en     : std_logic_vector(c_OUT_FUNC_VAR-1 downto 0);
   signal sl_write_st     : std_logic_vector(c_OUT_FUNC_VAR-1 downto 0);
   -- 
   -- 
   signal sl_halt             : std_logic;
   signal sl_halted           : std_logic;
   signal sl_halt_wr          : std_logic;
   signal sl_halt_rd          : std_logic;
   signal sl_param_halt_wr    : std_logic;
   signal sl_param_halt_rd    : std_logic;
   signal sl_done_wr          : std_logic;
   signal sl_done_rd          : std_logic;
   signal sl_stop_wr          : std_logic;
   signal sl_stop_rd          : std_logic;
   signal sl_fire_wr          : std_logic;
   signal sl_fire_rd          : std_logic;
   signal sl_sof_wr           : std_logic;
   signal sl_sof_rd           : std_logic;
   signal sl_error            : std_logic;

   --  
   -- Parameter related signals 
   signal sl_parameters_rd       : std_logic_vector(10 downto 0);
   signal sl_parameters_wr       : std_logic_vector(10 downto 0);
   signal sl_param_fifo_full  : std_logic;
   signal sl_sync_num  : std_logic_vector(9 downto 0);

   signal sl_RST : std_logic;

begin 

   ND_6_PARAM_FIFO_FULL <= sl_param_fifo_full;
   ND_6_SYNC_NUM <= sl_sync_num;

   sl_RST <= RST when RESET_HIGH=1 else not RST;
      ND_6IP_4_CLK   <= CLK;
      ND_6OP_1_CLK  <= CLK;

   --
   -- ==========================================================
   -- =       HWN Input related modules                        =
   -- ==========================================================
   -- Func. Input param. "tmp1"
   RD_MUX_0 : READ_MUX
   generic map (
      N_PORTS    => 1,
      PORT_WIDTH => 32
   )
   port map (
      IN_PORTS   => sl_IN_PORTS_0,
      EXISTS     => sl_EXISTS(0 downto 0),
      READS      => sl_READS(0 downto 0),
      SOFS       => sl_CTRLS(0 downto 0),

      OUT_PORT   => sl_in_port_0,
      EXIST      => sl_exist(0),
      READ       => sl_read(0),
      SOF        => sl_sof_rd,

      READ_EN    => sl_read_en(0),
      READ_ST    => sl_read_st(0),
      CONTROL    => sl_control_rd(0 downto 0),
      OBTAIN     => sl_obtain_rd(0 downto 0),
      RELEASE    => sl_release_rd(0 downto 0)
   );

   ND_6IP_4_Rd   <= sl_READS(0);

   sl_IN_PORTS_0 <= ND_6IP_4_Din;

   sl_EXISTS(0)   <= ND_6IP_4_Exist ;
   sl_CTRLS(0)    <= ND_6IP_4_CTRL ;

   EVAL_RD : pipeline2rtl_EVAL_LOGIC_RD_hwn_nd_6
   generic map ( 
      N_IN_PORTS    => c_IN_PORTS,
      WRAP          => c_WRAP,
      N_CNTRS       => c_COUNTERS,
      QUANT         => c_CNTR_QUANT,
      CNTR_STEP     => c_CNTR_STEPS,
      CNTR_WIDTH    => c_CNTR_WIDTHS
   )
   port map(
      RST           => sl_RST,
      CLK           => CLK,
      PARAMETERS    => sl_parameters_rd,
      REG_CNTRS     => sl_REG_CNTRS_RD,
      READ_EN       => sl_read_en,
      READ_ST       => sl_read_st,
      HALT          => sl_halt_rd,
      FIRE          => sl_fire_rd,
      DONE          => sl_done_rd,
      STOP          => sl_stop_rd,
      SOF           => sl_sof_rd,
      CONTROL       => sl_control_rd,
      OBTAIN        => sl_obtain_rd,
      RELEASE       => sl_release_rd
   );

   --
   -- ==========================================================
   -- =       HWN Output related modules                       =
   -- ==========================================================
   -- 
   -- Func. Output param. "tmp0"
   DEMUX_0 : WRITE_DEMUX
   generic map (
      N_PORTS => 1
   )
   port map (
      WRITES   => sl_WRITES(0 downto 0),
      FULLS    => sl_FULLS(0 downto 0),
      CONTROL  => sl_lortnoc_wr(0 downto 0),
      WRITE    => sl_write(0),
      FULL     => sl_full(0),
      WRITE_EN => sl_write_en(0),
      WRITE_ST => sl_write_st(0)
   );
   --
   ND_6OP_1_Dout <= sl_out_port_0;  -- Func. Output param. "tmp0"
   ND_6OP_1_CTRL <= sl_sof_wr ;
   ND_6OP_1_Wr   <= sl_WRITES(0);
   sl_FULLS(0) <= ND_6OP_1_Full;
   sl_lortnoc_wr(0) <= sl_control_wr(0);
   --
   --
   EVAL_WR : pipeline2rtl_EVAL_LOGIC_WR_hwn_nd_6
   generic map ( 
      N_OUT_PORTS   => c_OUT_PORTS,
      WRAP          => c_WRAP,
      N_CNTRS       => c_COUNTERS,
      QUANT         => c_CNTR_QUANT,
      CNTR_STEP     => c_CNTR_STEPS,
      CNTR_WIDTH    => c_CNTR_WIDTHS
   )
   port map (
      RST           => sl_RST,
      CLK           => CLK,
      PARAMETERS    => sl_parameters_wr,
      WRITE_EN      => sl_write_en,
      WRITE_ST      => sl_write_st,
      HALT          => sl_halt_wr,
      FIRE          => sl_fire_wr,
      DONE          => sl_done_wr,
      STOP          => sl_stop_wr,
      SOF           => sl_sof_wr,
      CONTROL       => sl_control_wr
   );

   --
   -- ==========================================================
   -- =       HWN Execution Unit                               =
   -- ==========================================================
   EX : pipeline2rtl_EXECUTION_UNIT_hwn_nd_6
   generic map (
      N_INPORTS  => c_IN_FUNC_VAR,
      N_OUTPORTS => c_OUT_FUNC_VAR, 
      IP_RESET   => c_IP_RESET,
      QUANT      => QUANT,
      STIM_DIR   => STIM_DIR,
      c_STAGES   => c_STAGES,
      N_CNTRS    => c_COUNTERS,
      CNTR_QUANT => c_CNTR_QUANT,
      CNTR_WIDTH => c_CNTR_WIDTHS
   )
   port map (
      RST        => sl_RST,
      CLK        => CLK,
      -- Iterators
      REG_CNTRS_RD => sl_REG_CNTRS_RD,
      -- Func. Input parameters
      IN_PORT_0    => sl_in_port_0,
      READ       => sl_read,
      EXIST      => sl_exist,
      -- Func. Output parameters
      OUT_PORT_0   => sl_out_port_0,
      WRITE      => sl_write,
      FULL       => sl_full,
      --
      STOP_WR    => sl_stop_wr,
      STOP_RD    => sl_stop_rd,
      ERROR      => sl_error
   );

   PAR_LOAD : PARAMETERS
   generic map ( 
      PAR_WIDTH    => PAR_WIDTH,
      PAR_BITWIDTH => c_PAR_BITWIDTH,
      PAR_VECTOR   => c_PAR_VECTOR,
      N_PAR        => c_N_PAR
   )
   port map(   
      RST        => sl_RST,
      CLK        => CLK,
      FIFO_FULL  => sl_param_fifo_full,
      HALT_RD    => sl_param_halt_rd,
      HALT_WR    => sl_param_halt_wr,
      SOF_RD     => sl_sof_rd,
      SOF_WR     => sl_sof_wr,
      PARAM_DT   => PARAM_DT,
      PARAM_LD   => PARAM_LD,
      SYNC_NUM   => sl_sync_num,
      PARAMETERS_RD => sl_parameters_rd,
      PARAMETERS_WR => sl_parameters_wr
   );

   sl_halt_rd <= sl_param_halt_rd;
--   sl_halt_wr <= sl_halt and sl_stop_rd;
   sl_halt_wr <= sl_param_halt_wr;
--   sl_halted  <= sl_sof_rd;
   STOP <= sl_done_wr;
   ERROR <= sl_error;
   BLOCK_RD <= not (  (  sl_READS(0)  ) );

end RTL;
