-- COPYRIGHT NOTICE (NOT TO BE REMOVED):
--
-- This file, or parts of it, or modified versions of it, may not be
-- copied, reproduced or transmitted in any form, including
-- reprinting, translation, photocopying or microfilming, or by any
-- means, electronic, mechanical or otherwise, or stored in a
-- retrieval system, or used for any purpose, without the prior
-- written permission of all Owners unless it is explicitly marked as
-- having Classification `Public'.
--
-- Classification: Restricted.
--
-- Owners of this file give notice:
-- (c) Copyright 2005 - 2009 Compaan Design bv, The Netherlands
-- All rights, including copyrights, reserved.
--
-- This file contains or may contain restricted information and is
-- UNPUBLISHED PROPRIETARY SOURCE CODE OF THE Owners. The Copyright
-- Notice(s) above do not evidence any actual or intended publication
-- of such source code. This file is additionally subject to the
-- conditions listed in the RESTRICTIONS file and is with NOWARRANTY.
--
-- END OF COPYRIGHT NOTICE
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity extern_connector is
    generic (
        RESET_HIGH   : natural := 1;
        C_FSL_DWIDTH : natural := 31
    );
    port (
        CLK : in std_logic;
        RST : in std_logic;
        --
        -- ============================================
        -- = External Connector interface (INPUT) 
        -- ============================================
        -- SRC (FSL_S Interface)
        FSL_S_Din      : in  STD_LOGIC_VECTOR(C_FSL_DWIDTH downto 0);
        FSL_S_CTRL     : in  STD_LOGIC;
        FSL_S_Rd       : out STD_LOGIC;
        FSL_S_Exist    : in  STD_LOGIC;
		FSL_S_CLK      : out std_logic;
        --
        -- SINK (FSL_M Interface)
        FSL_M_Dout     : out STD_LOGIC_VECTOR(C_FSL_DWIDTH downto 0);
        FSL_M_CTRL     : out STD_LOGIC;
        FSL_M_Wr       : out STD_LOGIC;
        FSL_M_Full     : in  STD_LOGIC;
		FSL_M_CLK      : out std_logic
    );
end extern_connector;

architecture STRUCTURE of extern_connector is

    signal ready : std_logic;
     
begin
        ready           <= FSL_S_Exist and not FSL_M_Full;
        FSL_S_Rd        <= ready;
        FSL_M_Wr        <= ready;       
        FSL_M_CTRL      <= FSL_S_CTRL;
        FSL_M_Dout      <= FSL_S_Din;
end architecture STRUCTURE;

