-- COPYRIGHT NOTICE (NOT TO BE REMOVED):
--
-- This file, or parts of it, or modified versions of it, may not be
-- copied, reproduced or transmitted in any form, including
-- reprinting, translation, photocopying or microfilming, or by any
-- means, electronic, mechanical or otherwise, or stored in a
-- retrieval system, or used for any purpose, without the prior
-- written permission of all Owners unless it is explicitly marked as
-- having Classification `Public'.
--
-- Classification: Restricted.
--
-- Owners of this file give notice:
-- (c) Copyright 2005 - 2009 Compaan Design bv, The Netherlands
-- All rights, including copyrights, reserved.
--
-- This file contains or may contain restricted information and is
-- UNPUBLISHED PROPRIETARY SOURCE CODE OF THE Owners. The Copyright
-- Notice(s) above do not evidence any actual or intended publication
-- of such source code. This file is additionally subject to the
-- conditions listed in the RESTRICTIONS file and is with NOWARRANTY.
--
-- END OF COPYRIGHT NOTICE
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity wire_connector is
  generic (
    C_EXT_RESET_HIGH    : integer := 1;
    C_ASYNC_CLKS        : integer := 0;
    C_IMPL_STYLE        : integer := 0;
    C_USE_CONTROL       : integer := 1;
    C_FSL_DWIDTH        : integer := 32;
    C_FSL_DEPTH         : integer := 16;
    C_READ_CLOCK_PERIOD : integer := 0
    );
  port (
    -- Clock and reset signals
    FSL_Clk : in  std_logic;
    SYS_Rst : in  std_logic;
    FSL_Rst : out std_logic;

    -- FSL master signals
    FSL_M_Clk     : in  std_logic;
    FSL_M_Data    : in  std_logic_vector(0 to C_FSL_DWIDTH-1);
    FSL_M_Control : in  std_logic;
    FSL_M_Write   : in  std_logic;
    FSL_M_Full    : out std_logic;

    -- FSL slave signals
    FSL_S_Clk     : in  std_logic;
    FSL_S_Data    : out std_logic_vector(0 to C_FSL_DWIDTH-1);
    FSL_S_Control : out std_logic;
    FSL_S_Read    : in  std_logic;
    FSL_S_Exists  : out std_logic;

    -- FIFO status signals
    FSL_Full        : out std_logic;
    FSL_Has_Data    : out std_logic;
    FSL_Control_IRQ : out std_logic
    );
end wire_connector;

architecture STRUCTURE of wire_connector is

    signal ready : std_logic;
     
begin
        
        ready           <= FSL_M_Write ;
        FSL_S_Exists    <= ready;
        FSL_S_Control   <= FSL_M_Control;
        FSL_S_Data      <= FSL_M_Data;
        
end architecture STRUCTURE;
