-- File automatically generated by KpnMapper
-- This file defines a template for pipelined function implementation
-- Function "filter_invert"

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library compaandesign_com_common_common_1_lib;
use compaandesign_com_common_common_1_lib.hw_node_pkg.all;


entity filter_invert_pipeline is
   generic (
      STIM_DIR   : string  := "bla";
      c_STAGES   : natural := 1;
      N_CNTRS    : natural := 1;
      CNTR_QUANT : natural := 32;
      CNTR_WIDTH : t_counter_width := ( 0=>10, 1=>10, 2=>9, others=>10 )
   );
   port (
      RST   : in  std_logic;
      CLK   : in  std_logic;
      -- Inputs 
      ip_in  : in  std_logic_vector(31 downto 0);
      -- Iterators 
      it_j : in  std_logic_vector(CNTR_WIDTH(0)-1 downto 0);
      it_i : in  std_logic_vector(CNTR_WIDTH(1)-1 downto 0);
      -- Outputs 
      op_out : out std_logic_vector(31 downto 0);
      --
      ENi   : in  std_logic;
      EN    : in  std_logic_vector(c_STAGES-1 downto 0);
      STALL_FRONT  : out std_logic_vector(c_STAGES-1 downto 0);
      STALL_BACK   : out std_logic_vector(c_STAGES-1 downto 0);
      ERROR : out std_logic
   );
end filter_invert_pipeline;

architecture RTL of filter_invert_pipeline is
--
    constant error_int : integer := -1;
    constant reset_int : std_logic_vector(0 downto 0) := b"0";
    -- Input registers
    signal ipr_in : std_logic_vector(31 downto 0);

    -- Iterator registers 
    signal itr_j : std_logic_vector(CNTR_WIDTH(0)-1 downto 0);
    signal itr_i : std_logic_vector(CNTR_WIDTH(1)-1 downto 0);
    --

    --
    -- Your pipeline signals
    --
    -- STAGE_0
    signal s0_in : std_logic_vector(31 downto 0);
    signal r0_in : std_logic_vector(31 downto 0);

begin

    PIPE_REGS : process(CLK)
    begin
        if rising_edge(CLK) then
            if (RST='1') then
                -- Something to reset?
            else
                if( ENi = '1' ) then
                    -- Input Registers 
                    ipr_in <= ip_in;
                    -- Iterator Registers 
                    itr_j <= it_j;
                    itr_i <= it_i;
                end if;
                -- Pipeline Depth: 1 stages
                -- STAGE_0
                if( EN(0) = '1' ) then
                    r0_in <= not s0_in;
                end if;
            end if;
        end if;
    end process;    -- PIPE_REGS
    --
    -- Output
    op_out <= STD_LOGIC_VECTOR(RESIZE(UNSIGNED(r0_in), op_out'Length));
    --
    -- PIPE_COMB:
    s0_in <= ipr_in;
    --
    STALL_FRONT  <= (others=>'0');
    STALL_BACK   <= (others=>'0');
    ERROR <= '0';
end RTL;


