-- File automatically generated by KpnMapper
-- This file descibes the orignal Function
-- Function "compaan_outlinedproc9"

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library compaandesign_com_common_common_1_lib;
use compaandesign_com_common_common_1_lib.hw_node_pkg.all;

library compaandesign_com_common_hwnode_1_lib;
use compaandesign_com_common_hwnode_1_lib.all;


entity compaan_outlinedproc9 is
   generic (
      STIM_DIR   : string  := "bla";
      c_STAGES   : natural := 1;
      N_CNTRS    : natural := 1;
      CNTR_QUANT : natural := 32;
      CNTR_WIDTH : t_counter_width := ( 0=>10, 1=>10, 2=>9, others=>10 )
   );
   port (
      RST   : in  std_logic;
      CLK   : in  std_logic;
      -- Inputs 
      ip_tmp1  : in  std_logic_vector(31 downto 0);
      EXIST : in  std_logic_vector(0 downto 0);
      READF : out std_logic_vector(0 downto 0);
      -- Iterators 
      it_x : in  std_logic_vector(CNTR_WIDTH(0)-1 downto 0);
      it_y : in  std_logic_vector(CNTR_WIDTH(1)-1 downto 0);
      -- Outputs 
      op_tmp0 : out std_logic_vector(31 downto 0);
      FULL  : in  std_logic_vector(0 downto 0);
      WRITEF: out std_logic_vector(0 downto 0);
      --
      STOP_RD : in  std_logic;
      STOP_WR : in  std_logic;
      ERROR   : out std_logic
   );
end compaan_outlinedproc9;

architecture RTL of compaan_outlinedproc9 is

   component compaan_outlinedproc9_pipeline is
      generic (
         STIM_DIR   : string  := "bla";
         c_STAGES   : natural := 1;
         N_CNTRS    : natural := 1; 
         CNTR_QUANT : natural := 32; 
         CNTR_WIDTH : t_counter_width := ( 0=>10, 1=>10, 2=>9, others=>10 ) 
      );
      port (
         RST   : in std_logic;
         CLK   : in std_logic;
         -- Inputs 
         ip_tmp1  : in  std_logic_vector(31 downto 0);  
         -- Iterators 
         it_x : in  std_logic_vector(CNTR_WIDTH(0)-1 downto 0);
         it_y : in  std_logic_vector(CNTR_WIDTH(1)-1 downto 0);
         -- Outputs 
         op_tmp0 : out std_logic_vector(31 downto 0);

         ENi   : in  std_logic;
         EN    : in  std_logic_vector(c_STAGES-1 downto 0);
         STALL_FRONT  : out std_logic_vector(c_STAGES-1 downto 0);
         STALL_BACK   : out std_logic_vector(c_STAGES-1 downto 0);
         ERROR : out std_logic
      );
   end component;

   component CONTROLLER is
      generic ( 
         N_STAGES  : natural := 1;
         BLOCKING  : natural := 0
      ); 
      port (
         READ      : out std_logic;
         EXIST     : in  std_logic;
         WRITE     : out std_logic;
         FULL      : in  std_logic;
         --
         ENABLE_EX    : out std_logic_vector(N_STAGES-1 downto 0);
         STALL_FRONT  : in  std_logic_vector(N_STAGES-1 downto 0);
         STALL_BACK   : in  std_logic_vector(N_STAGES-1 downto 0);
         --
         CLK       : in  std_logic;
         RST       : in  std_logic
      );
   end component;

   constant c_BLOCKING : natural := 1;

   signal sl_EXIST : std_logic;
   signal sl_READ  : std_logic;
   signal sl_FULL  : std_logic;
   signal sl_WRITE : std_logic;
   signal sl_EN    : std_logic_vector(c_STAGES-1 downto 0);
   signal sl_STALL_FRONT  : std_logic_vector(c_STAGES-1 downto 0);
   signal sl_STALL_BACK   : std_logic_vector(c_STAGES-1 downto 0);
   --

   --

   --

begin

   -- if all arguments exist, and we do not stop reading, make sl_EXIST high mean you can fire
   sl_EXIST <= '1' when ((STOP_RD='0') and (EXIST=(EXIST'range=>'1'))) else '0';
   -- Functional Evaluation. Only when all signals are high, we can set READF high.
   READF    <= (READF'range =>sl_READ);
   sl_FULL  <= '0' when ((STOP_WR='0') and (FULL =(FULL'range =>'0'))) else '1';
   WRITEF   <= (WRITEF'range=>sl_WRITE);

   PIPELINE : compaan_outlinedproc9_pipeline
   generic map (
         STIM_DIR      => STIM_DIR,
         c_STAGES      => c_STAGES,
         N_CNTRS       => N_CNTRS,
         CNTR_QUANT    => CNTR_QUANT,
         CNTR_WIDTH    => CNTR_WIDTH
   )
   port map (
      CLK   => CLK,
      RST   => RST,
      -- Inputs 
      ip_tmp1 => ip_tmp1,
      -- Iterators 
      it_x => it_x,
      it_y => it_y,
      -- Outputs 
      op_tmp0 => op_tmp0,
      --
      ENi         => sl_READ,
      EN          => sl_EN,
      STALL_FRONT => sl_STALL_FRONT,
      STALL_BACK  => sl_STALL_BACK,
      ERROR       => ERROR
   );

   CTRL : CONTROLLER
   generic map (
      N_STAGES   => c_STAGES,
      BLOCKING   => c_BLOCKING
   )
   port map (
      RST        => RST,
      CLK        => CLK,
      READ       => sl_READ,
      EXIST      => sl_EXIST,
      --
      ENABLE_EX   => sl_EN,
      STALL_FRONT => sl_STALL_FRONT,
      STALL_BACK  => sl_STALL_BACK,
      --
      WRITE      => sl_WRITE,
      FULL       => sl_FULL
   );

end RTL;

