-- File automatically generated by KpnMapper
-- This file defines a template for pipelined function implementation
-- Function "compaan_outlinedproc9"

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library compaandesign_com_common_common_1_lib;
use compaandesign_com_common_common_1_lib.hw_node_pkg.all;


entity compaan_outlinedproc9_pipeline is
   generic (
      STIM_DIR   : string  := "bla";
      c_STAGES   : natural := 1;
      N_CNTRS    : natural := 1;
      CNTR_QUANT : natural := 32;
      CNTR_WIDTH : t_counter_width := ( 0=>10, 1=>10, 2=>9, others=>10 )
   );
   port (
      RST   : in  std_logic;
      CLK   : in  std_logic;
      -- Inputs 
      ip_tmp1  : in  std_logic_vector(31 downto 0);
      -- Iterators 
      it_x : in  std_logic_vector(CNTR_WIDTH(0)-1 downto 0);
      it_y : in  std_logic_vector(CNTR_WIDTH(1)-1 downto 0);
      -- Outputs 
      op_tmp0 : out std_logic_vector(31 downto 0);
      --
      ENi   : in  std_logic;
      EN    : in  std_logic_vector(c_STAGES-1 downto 0);
      STALL_FRONT  : out std_logic_vector(c_STAGES-1 downto 0);
      STALL_BACK   : out std_logic_vector(c_STAGES-1 downto 0);
      ERROR : out std_logic
   );
end compaan_outlinedproc9_pipeline;

architecture RTL of compaan_outlinedproc9_pipeline is
--
    constant error_int : integer := -1;
    constant reset_int : std_logic_vector(0 downto 0) := b"0";
    -- Input registers
    signal ipr_tmp1 : std_logic_vector(31 downto 0);

    -- Iterator registers 
    signal itr_x : std_logic_vector(CNTR_WIDTH(0)-1 downto 0);
    signal itr_y : std_logic_vector(CNTR_WIDTH(1)-1 downto 0);
    --

    --
    -- Your pipeline signals
    --
    -- STAGE_0
    signal s0_tmp1 : std_logic_vector(31 downto 0);
    signal r0_tmp1 : std_logic_vector(31 downto 0);

begin

    PIPE_REGS : process(CLK)
    begin
        if rising_edge(CLK) then
            if (RST='1') then
                -- Something to reset?
            else
                if( ENi = '1' ) then
                    -- Input Registers 
                    ipr_tmp1 <= ip_tmp1;
                    -- Iterator Registers 
                    itr_x <= it_x;
                    itr_y <= it_y;
                end if;
                -- Pipeline Depth: 1 stages
                -- STAGE_0
                if( EN(0) = '1' ) then
                    r0_tmp1 <= s0_tmp1;
                end if;
            end if;
        end if;
    end process;    -- PIPE_REGS
    --
    -- Output
    op_tmp0 <= STD_LOGIC_VECTOR(RESIZE(UNSIGNED(r0_tmp1), op_tmp0'Length));
    --
    -- PIPE_COMB:
    s0_tmp1 <= ipr_tmp1;
    --
    STALL_FRONT  <= (others=>'0');
    STALL_BACK   <= (others=>'0');
    ERROR <= '0';
end RTL;


