-------------------------------------------------------------------------------
-- pipeline2rtl_hwn_nd_2_ip_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library compaandesign_com_pipeline2rtl_hwn_nd_2_1_lib;
use compaandesign_com_pipeline2rtl_hwn_nd_2_1_lib.all;

entity pipeline2rtl_hwn_nd_2_ip_wrapper is
  port (
    data_in_Rd : out std_logic;
    data_in_Din : in std_logic_vector(31 downto 0);
    data_in_Exist : in std_logic;
    data_in_CLK : out std_logic;
    data_in_CTRL : in std_logic;
    ND_2OP_1_Wr : out std_logic;
    ND_2OP_1_Dout : out std_logic_vector(31 downto 0);
    ND_2OP_1_Full : in std_logic;
    ND_2OP_1_CLK : out std_logic;
    ND_2OP_1_CTRL : out std_logic;
    PARAM_DT : in std_logic_vector(20 downto 0);
    PARAM_LD : in std_logic;
    STOP : out std_logic;
    ERROR : out std_logic;
    BLOCK_RD : out std_logic;
    RST : in std_logic;
    CLK : in std_logic
  );
  
  
end pipeline2rtl_hwn_nd_2_ip_wrapper;

architecture STRUCTURE of pipeline2rtl_hwn_nd_2_ip_wrapper is

  component pipeline2rtl_hwn_nd_2 is
	generic (
		RESET_HIGH : NATURAL := 1;
		PAR_WIDTH : NATURAL := 16;
		QUANT : NATURAL := 32;
		WRAP : BOOLEAN := true;
		STIM_DIR : STRING := "hwn_nd_2"
	);
	port (
		data_in_Rd : out std_logic;
		data_in_Din : in std_logic_vector(31 downto 0);
		data_in_Exist : in std_logic;
		data_in_CLK : out std_logic;
		data_in_CTRL : in std_logic;
		ND_2OP_1_Wr : out std_logic;
		ND_2OP_1_Dout : out std_logic_vector(31 downto 0);
		ND_2OP_1_Full : in std_logic;
		ND_2OP_1_CLK : out std_logic;
		ND_2OP_1_CTRL : out std_logic;
		PARAM_DT : in std_logic_vector(20 downto 0);
		PARAM_LD : in std_logic;
		STOP : out std_logic;
		ERROR : out std_logic;
		BLOCK_RD : out std_logic;
		RST : in std_logic;
		CLK : in std_logic
	);
end component;

begin

pipeline2rtl_hwn_nd_2_ip_wrapper_ip : pipeline2rtl_hwn_nd_2
	generic map (
		RESET_HIGH => 1,
		PAR_WIDTH => 11,
		QUANT => 32,
		WRAP => true,
		STIM_DIR => "compaandesign_com/pipeline2rtl/hwn_nd_2/tb/data/"
	)
    port map (
		data_in_Rd => data_in_Rd,
		data_in_Din => data_in_Din,
		data_in_Exist => data_in_Exist,
		data_in_CLK => data_in_CLK,
		data_in_CTRL => data_in_CTRL,
		ND_2OP_1_Wr => ND_2OP_1_Wr,
		ND_2OP_1_Dout => ND_2OP_1_Dout,
		ND_2OP_1_Full => ND_2OP_1_Full,
		ND_2OP_1_CLK => ND_2OP_1_CLK,
		ND_2OP_1_CTRL => ND_2OP_1_CTRL,
		PARAM_DT => PARAM_DT,
		PARAM_LD => PARAM_LD,
		STOP => STOP,
		ERROR => ERROR,
		BLOCK_RD => BLOCK_RD,
		RST => RST,
		CLK => CLK
    );
  
end architecture STRUCTURE;
