-------------------------------------------------------------------------------
-- pipeline2rtl_register_rf_ip_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library compaandesign_com_pipeline2rtl_register_rf_1_lib;
use compaandesign_com_pipeline2rtl_register_rf_1_lib.all;

entity pipeline2rtl_register_rf_ip_wrapper is
  port (
    address : in std_logic_vector(18 downto 0);
    read_data : out std_logic_vector(31 downto 0);
    read_en : in std_logic;
    write_en : in std_logic;
    write_data : in std_logic_vector(31 downto 0);
    pci_clk : in std_logic;
    split_x_rf_read_data : in std_logic_vector(31 downto 0);
    split_x_rf_read_en : out std_logic;
    split_x_rf_write_en : out std_logic;
    split_x_rf_write_data : out std_logic_vector(31 downto 0);
    commit_rf_read_data : in std_logic_vector(31 downto 0);
    commit_rf_read_en : out std_logic;
    commit_rf_write_en : out std_logic;
    commit_rf_write_data : out std_logic_vector(31 downto 0);
    RST : in std_logic;
    CLK : in std_logic
  );
  
  
end pipeline2rtl_register_rf_ip_wrapper;

architecture STRUCTURE of pipeline2rtl_register_rf_ip_wrapper is

  component pipeline2rtl_register_rf is
	generic (
		C_split_x_rf_address : std_logic_vector := B"0000000000000000000";
		C_commit_rf_address : std_logic_vector := B"0000000000000000100"
	);
	port (
		address : in std_logic_vector(18 downto 0);
		read_data : out std_logic_vector(31 downto 0);
		read_en : in std_logic;
		write_en : in std_logic;
		write_data : in std_logic_vector(31 downto 0);
		pci_clk : in std_logic;
		split_x_rf_read_data : in std_logic_vector(31 downto 0);
		split_x_rf_read_en : out std_logic;
		split_x_rf_write_en : out std_logic;
		split_x_rf_write_data : out std_logic_vector(31 downto 0);
		commit_rf_read_data : in std_logic_vector(31 downto 0);
		commit_rf_read_en : out std_logic;
		commit_rf_write_en : out std_logic;
		commit_rf_write_data : out std_logic_vector(31 downto 0);
		RST : in std_logic;
		CLK : in std_logic
	);
end component;

begin

pipeline2rtl_register_rf_ip_wrapper_ip : pipeline2rtl_register_rf
	generic map (
		C_split_x_rf_address => B"0000000000000000000",
		C_commit_rf_address => B"0000000000000000100"
	)
    port map (
		address => address,
		read_data => read_data,
		read_en => read_en,
		write_en => write_en,
		write_data => write_data,
		pci_clk => pci_clk,
		split_x_rf_read_data => split_x_rf_read_data,
		split_x_rf_read_en => split_x_rf_read_en,
		split_x_rf_write_en => split_x_rf_write_en,
		split_x_rf_write_data => split_x_rf_write_data,
		commit_rf_read_data => commit_rf_read_data,
		commit_rf_read_en => commit_rf_read_en,
		commit_rf_write_en => commit_rf_write_en,
		commit_rf_write_data => commit_rf_write_data,
		RST => RST,
		CLK => CLK
    );
  
end architecture STRUCTURE;
