-------------------------------------------------------------------------------
-- ipcore2RTL_hwn_nd_3_ip_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity ipcore2RTL_hwn_nd_3_ip_wrapper is
  port (
    ND_3IP_2_Rd : out std_logic;
    ND_3IP_2_Din : in std_logic_vector(31 downto 0);
    ND_3IP_2_Exist : in std_logic;
    ND_3IP_2_CLK : out std_logic;
    ND_3IP_2_CTRL : in std_logic;
    data_out_Wr : out std_logic;
    data_out_Dout : out std_logic_vector(31 downto 0);
    data_out_Full : in std_logic;
    data_out_CLK : out std_logic;
    data_out_CTRL : out std_logic;
    PARAM_DT : in std_logic_vector(31 downto 0);
    PARAM_LD : in std_logic;
    STOP : out std_logic;
    ERROR : out std_logic;
    BLOCK_RD : out std_logic;
    RST : in std_logic;
    CLK : in std_logic
  );
  
  
end ipcore2RTL_hwn_nd_3_ip_wrapper;

architecture STRUCTURE of ipcore2RTL_hwn_nd_3_ip_wrapper is

  component ipcore2rtl_hwn_nd_3 is
	generic (
		RESET_HIGH : NATURAL := 1;
		PAR_WIDTH : NATURAL := 32;
		QUANT : NATURAL := 32;
		WRAP : BOOLEAN := true
	);
	port (
		ND_3IP_2_Rd : out std_logic;
		ND_3IP_2_Din : in std_logic_vector(31 downto 0);
		ND_3IP_2_Exist : in std_logic;
		ND_3IP_2_CLK : out std_logic;
		ND_3IP_2_CTRL : in std_logic;
		data_out_Wr : out std_logic;
		data_out_Dout : out std_logic_vector(31 downto 0);
		data_out_Full : in std_logic;
		data_out_CLK : out std_logic;
		data_out_CTRL : out std_logic;
		PARAM_DT : in std_logic_vector(31 downto 0);
		PARAM_LD : in std_logic;
		STOP : out std_logic;
		ERROR : out std_logic;
		BLOCK_RD : out std_logic;
		RST : in std_logic;
		CLK : in std_logic
	);
end component;

begin

ipcore2RTL_hwn_nd_3_ip_wrapper_ip : ipcore2rtl_hwn_nd_3
	generic map (
		RESET_HIGH => 1,
		PAR_WIDTH => 32,
		QUANT => 32,
		WRAP => true
	)
    port map (
		ND_3IP_2_Rd => ND_3IP_2_Rd,
		ND_3IP_2_Din => ND_3IP_2_Din,
		ND_3IP_2_Exist => ND_3IP_2_Exist,
		ND_3IP_2_CLK => ND_3IP_2_CLK,
		ND_3IP_2_CTRL => ND_3IP_2_CTRL,
		data_out_Wr => data_out_Wr,
		data_out_Dout => data_out_Dout,
		data_out_Full => data_out_Full,
		data_out_CLK => data_out_CLK,
		data_out_CTRL => data_out_CTRL,
		PARAM_DT => PARAM_DT,
		PARAM_LD => PARAM_LD,
		STOP => STOP,
		ERROR => ERROR,
		BLOCK_RD => BLOCK_RD,
		RST => RST,
		CLK => CLK
    );
  
end architecture STRUCTURE;
