-------------------------------------------------------------------------------
-- ipcore2RTL_register_rf_ip_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity ipcore2RTL_register_rf_ip_wrapper is
  port (
    address : in std_logic_vector(18 downto 0);
    read_data : out std_logic_vector(31 downto 0);
    read_en : in std_logic;
    write_en : in std_logic;
    write_data : in std_logic_vector(31 downto 0);
		reg_rf_read_data  : in std_logic_vector(32-1 downto 0);
		reg_rf_read_en    : out std_logic;
		reg_rf_write_en   : out std_logic;
		reg_rf_write_data : out std_logic_vector(32-1 downto 0);	    
    RST : in std_logic;
    CLK : in std_logic
  );
  
  
end ipcore2RTL_register_rf_ip_wrapper;

architecture STRUCTURE of ipcore2RTL_register_rf_ip_wrapper is

  component register_rf is
	port (
		address : in std_logic_vector(18 downto 0);
		read_data : out std_logic_vector(31 downto 0);
		read_en : in std_logic;
		write_en : in std_logic;
		write_data : in std_logic_vector(31 downto 0);
		reg_rf_read_data  : in std_logic_vector(32-1 downto 0);   
		reg_rf_read_en    : out std_logic;                        
		reg_rf_write_en   : out std_logic;                        
		reg_rf_write_data : out std_logic_vector(32-1 downto 0);			
		RST : in std_logic;
		CLK : in std_logic
	);
end component;

begin

ipcore2RTL_register_rf_ip_wrapper_ip : register_rf
    port map (
		address => address,
		read_data => read_data,
		read_en => read_en,
		write_en => write_en,
		write_data => write_data,
		reg_rf_read_data   => reg_rf_read_data, 
		reg_rf_read_en     => reg_rf_read_en,   
		reg_rf_write_en    => reg_rf_write_en,  
		reg_rf_write_data  => reg_rf_write_data,		
		RST => RST,
		CLK => CLK
    );
  
end architecture STRUCTURE;
