from dp_stream_pkg import *

from random import randrange
from dp_block_gen import dp_block_gen

ACTIVE_LOW, INACTIVE_HIGH = 0, 1

def tb_dp_block_gen():
    dp_block_gen_dp_bus = DPBus(data_w=2)

    clock  = Signal(intbv(0))

    reset = ResetSignal(0, active=ACTIVE_LOW, async=True)

    bg = dp_block_gen(dp_block_gen_dp_bus, clock, reset, g_count_max=4)

    HALF_PERIOD = delay(10)

    @always(HALF_PERIOD)
    def clockGen():
        clock.next = not clock

    @instance
    def stimulus():
        reset.next = ACTIVE_LOW
        yield clock.negedge
        reset.next = INACTIVE_HIGH
        for i in range(12):
            dp_block_gen_dp_bus.ready.next = bool(min(1, randrange(3)))
            yield clock.negedge
        raise StopSimulation

    @instance
    def monitor():
        print "ready  data  valid    sop     eop"
        yield reset.posedge
        while 1:
            yield clock.posedge
            yield delay(1)
            print "   %s     %s    %s     %s     %s" % (dp_block_gen_dp_bus.ready, dp_block_gen_dp_bus.data, dp_block_gen_dp_bus.valid, dp_block_gen_dp_bus.sop, dp_block_gen_dp_bus.eop)

    return clockGen, stimulus, bg, monitor


# Optie 1: alleen print output
#tb = tb_dp_block_gen()
#Simulation(tb).run()

# Optie 2: waveform
tb = traceSignals(tb_dp_block_gen)
sim = Simulation(tb)
sim.run()
