-------------------------------------------------------------------------------
-- pipeline2rtl_control_if_ip_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library compaandesign_com_pipeline2rtl_control_if_1_lib;
use compaandesign_com_pipeline2rtl_control_if_1_lib.all;

entity pipeline2rtl_control_if_ip_wrapper is
  port (
    PARAM_DT : out std_logic_vector(20 downto 0);
    PARAM_LD : out std_logic;
    SYNC_NUM : in std_logic_vector(9 downto 0);
    PARAM_FIFO_FULL : in std_logic;
    PARAMETERS_IN : in std_logic_vector(10 downto 0);
    PARAMETERS_IN_LD : in std_logic;
    RST : in std_logic;
    CLK : in std_logic
  );
  
  
end pipeline2rtl_control_if_ip_wrapper;

architecture STRUCTURE of pipeline2rtl_control_if_ip_wrapper is

  component pipeline2rtl_control_if is
	generic (
		RESET_HIGH : NATURAL := 1;
		QUANT : NATURAL := 32
	);
	port (
		PARAM_DT : out std_logic_vector(20 downto 0);
		PARAM_LD : out std_logic;
		SYNC_NUM : in std_logic_vector(9 downto 0);
		PARAM_FIFO_FULL : in std_logic;
		PARAMETERS_IN : in std_logic_vector(10 downto 0);
		PARAMETERS_IN_LD : in std_logic;
		RST : in std_logic;
		CLK : in std_logic
	);
end component;

begin

pipeline2rtl_control_if_ip_wrapper_ip : pipeline2rtl_control_if
	generic map (
		RESET_HIGH => 1,
		QUANT => 11
	)
    port map (
		PARAM_DT => PARAM_DT,
		PARAM_LD => PARAM_LD,
		SYNC_NUM => SYNC_NUM,
		PARAM_FIFO_FULL => PARAM_FIFO_FULL,
		PARAMETERS_IN => PARAMETERS_IN,
		PARAMETERS_IN_LD => PARAMETERS_IN_LD,
		RST => RST,
		CLK => CLK
    );
  
end architecture STRUCTURE;
