-------------------------------------------------------------------------------
-- pipeline2rtl_hwn_nd_8_ip_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library compaandesign_com_pipeline2rtl_hwn_nd_8_1_lib;
use compaandesign_com_pipeline2rtl_hwn_nd_8_1_lib.all;

entity pipeline2rtl_hwn_nd_8_ip_wrapper is
  port (
    ND_8IP_6_Rd : out std_logic;
    ND_8IP_6_Din : in std_logic_vector(31 downto 0);
    ND_8IP_6_Exist : in std_logic;
    ND_8IP_6_CLK : out std_logic;
    ND_8IP_6_CTRL : in std_logic;
    ND_8OP_1_Wr : out std_logic;
    ND_8OP_1_Dout : out std_logic_vector(31 downto 0);
    ND_8OP_1_Full : in std_logic;
    ND_8OP_1_CLK : out std_logic;
    ND_8OP_1_CTRL : out std_logic;
    PARAM_DT : in std_logic_vector(20 downto 0);
    PARAM_LD : in std_logic;
    ND_8_PARAM_FIFO_FULL : out std_logic;
    ND_8_SYNC_NUM : out std_logic_vector(9 downto 0);
    STOP : out std_logic;
    ERROR : out std_logic;
    BLOCK_RD : out std_logic;
    RST : in std_logic;
    CLK : in std_logic
  );
  
  
end pipeline2rtl_hwn_nd_8_ip_wrapper;

architecture STRUCTURE of pipeline2rtl_hwn_nd_8_ip_wrapper is

  component pipeline2rtl_hwn_nd_8 is
	generic (
		RESET_HIGH : NATURAL := 1;
		PAR_WIDTH : NATURAL := 16;
		QUANT : NATURAL := 32;
		WRAP : BOOLEAN := true;
		STIM_DIR : STRING := "hwn_nd_8"
	);
	port (
		ND_8IP_6_Rd : out std_logic;
		ND_8IP_6_Din : in std_logic_vector(31 downto 0);
		ND_8IP_6_Exist : in std_logic;
		ND_8IP_6_CLK : out std_logic;
		ND_8IP_6_CTRL : in std_logic;
		ND_8OP_1_Wr : out std_logic;
		ND_8OP_1_Dout : out std_logic_vector(31 downto 0);
		ND_8OP_1_Full : in std_logic;
		ND_8OP_1_CLK : out std_logic;
		ND_8OP_1_CTRL : out std_logic;
		PARAM_DT : in std_logic_vector(20 downto 0);
		PARAM_LD : in std_logic;
		ND_8_PARAM_FIFO_FULL : out std_logic;
		ND_8_SYNC_NUM : out std_logic_vector(9 downto 0);
		STOP : out std_logic;
		ERROR : out std_logic;
		BLOCK_RD : out std_logic;
		RST : in std_logic;
		CLK : in std_logic
	);
end component;

begin

pipeline2rtl_hwn_nd_8_ip_wrapper_ip : pipeline2rtl_hwn_nd_8
	generic map (
		RESET_HIGH => 1,
		PAR_WIDTH => 11,
		QUANT => 32,
		WRAP => true,
		STIM_DIR => "compaandesign_com/pipeline2rtl/hwn_nd_8/tb/data/"
	)
    port map (
		ND_8IP_6_Rd => ND_8IP_6_Rd,
		ND_8IP_6_Din => ND_8IP_6_Din,
		ND_8IP_6_Exist => ND_8IP_6_Exist,
		ND_8IP_6_CLK => ND_8IP_6_CLK,
		ND_8IP_6_CTRL => ND_8IP_6_CTRL,
		ND_8OP_1_Wr => ND_8OP_1_Wr,
		ND_8OP_1_Dout => ND_8OP_1_Dout,
		ND_8OP_1_Full => ND_8OP_1_Full,
		ND_8OP_1_CLK => ND_8OP_1_CLK,
		ND_8OP_1_CTRL => ND_8OP_1_CTRL,
		PARAM_DT => PARAM_DT,
		PARAM_LD => PARAM_LD,
		ND_8_PARAM_FIFO_FULL => ND_8_PARAM_FIFO_FULL,
		ND_8_SYNC_NUM => ND_8_SYNC_NUM,
		STOP => STOP,
		ERROR => ERROR,
		BLOCK_RD => BLOCK_RD,
		RST => RST,
		CLK => CLK
    );
  
end architecture STRUCTURE;
