-------------------------------------------------------------------------------
-- pipeline2rtl_hwn_nd_9_ip_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library compaandesign_com_pipeline2rtl_hwn_nd_9_1_lib;
use compaandesign_com_pipeline2rtl_hwn_nd_9_1_lib.all;

entity pipeline2rtl_hwn_nd_9_ip_wrapper is
  port (
    ND_9IP_7_Rd : out std_logic;
    ND_9IP_7_Din : in std_logic_vector(31 downto 0);
    ND_9IP_7_Exist : in std_logic;
    ND_9IP_7_CLK : out std_logic;
    ND_9IP_7_CTRL : in std_logic;
    ND_9IP_8_Rd : out std_logic;
    ND_9IP_8_Din : in std_logic_vector(31 downto 0);
    ND_9IP_8_Exist : in std_logic;
    ND_9IP_8_CLK : out std_logic;
    ND_9IP_8_CTRL : in std_logic;
    ND_9OP_1_ND_9OP_1_d1_Wr : out std_logic;
    ND_9OP_1_ND_9OP_1_d1_Dout : out std_logic_vector(31 downto 0);
    ND_9OP_1_ND_9OP_1_d1_Full : in std_logic;
    ND_9OP_1_ND_9OP_1_d1_CLK : out std_logic;
    ND_9OP_1_ND_9OP_1_d1_CTRL : out std_logic;
    PARAM_DT : in std_logic_vector(20 downto 0);
    PARAM_LD : in std_logic;
    ND_9_PARAM_FIFO_FULL : out std_logic;
    ND_9_SYNC_NUM : out std_logic_vector(9 downto 0);
    STOP : out std_logic;
    ERROR : out std_logic;
    BLOCK_RD : out std_logic;
    RST : in std_logic;
    CLK : in std_logic
  );
  
  
end pipeline2rtl_hwn_nd_9_ip_wrapper;

architecture STRUCTURE of pipeline2rtl_hwn_nd_9_ip_wrapper is

  component pipeline2rtl_hwn_nd_9 is
	generic (
		RESET_HIGH : NATURAL := 1;
		PAR_WIDTH : NATURAL := 16;
		QUANT : NATURAL := 32;
		WRAP : BOOLEAN := true;
		STIM_DIR : STRING := "hwn_nd_9"
	);
	port (
		ND_9IP_7_Rd : out std_logic;
		ND_9IP_7_Din : in std_logic_vector(31 downto 0);
		ND_9IP_7_Exist : in std_logic;
		ND_9IP_7_CLK : out std_logic;
		ND_9IP_7_CTRL : in std_logic;
		ND_9IP_8_Rd : out std_logic;
		ND_9IP_8_Din : in std_logic_vector(31 downto 0);
		ND_9IP_8_Exist : in std_logic;
		ND_9IP_8_CLK : out std_logic;
		ND_9IP_8_CTRL : in std_logic;
		ND_9OP_1_ND_9OP_1_d1_Wr : out std_logic;
		ND_9OP_1_ND_9OP_1_d1_Dout : out std_logic_vector(31 downto 0);
		ND_9OP_1_ND_9OP_1_d1_Full : in std_logic;
		ND_9OP_1_ND_9OP_1_d1_CLK : out std_logic;
		ND_9OP_1_ND_9OP_1_d1_CTRL : out std_logic;
		PARAM_DT : in std_logic_vector(20 downto 0);
		PARAM_LD : in std_logic;
		ND_9_PARAM_FIFO_FULL : out std_logic;
		ND_9_SYNC_NUM : out std_logic_vector(9 downto 0);
		STOP : out std_logic;
		ERROR : out std_logic;
		BLOCK_RD : out std_logic;
		RST : in std_logic;
		CLK : in std_logic
	);
end component;

begin

pipeline2rtl_hwn_nd_9_ip_wrapper_ip : pipeline2rtl_hwn_nd_9
	generic map (
		RESET_HIGH => 1,
		PAR_WIDTH => 11,
		QUANT => 32,
		WRAP => true,
		STIM_DIR => "compaandesign_com/pipeline2rtl/hwn_nd_9/tb/data/"
	)
    port map (
		ND_9IP_7_Rd => ND_9IP_7_Rd,
		ND_9IP_7_Din => ND_9IP_7_Din,
		ND_9IP_7_Exist => ND_9IP_7_Exist,
		ND_9IP_7_CLK => ND_9IP_7_CLK,
		ND_9IP_7_CTRL => ND_9IP_7_CTRL,
		ND_9IP_8_Rd => ND_9IP_8_Rd,
		ND_9IP_8_Din => ND_9IP_8_Din,
		ND_9IP_8_Exist => ND_9IP_8_Exist,
		ND_9IP_8_CLK => ND_9IP_8_CLK,
		ND_9IP_8_CTRL => ND_9IP_8_CTRL,
		ND_9OP_1_ND_9OP_1_d1_Wr => ND_9OP_1_ND_9OP_1_d1_Wr,
		ND_9OP_1_ND_9OP_1_d1_Dout => ND_9OP_1_ND_9OP_1_d1_Dout,
		ND_9OP_1_ND_9OP_1_d1_Full => ND_9OP_1_ND_9OP_1_d1_Full,
		ND_9OP_1_ND_9OP_1_d1_CLK => ND_9OP_1_ND_9OP_1_d1_CLK,
		ND_9OP_1_ND_9OP_1_d1_CTRL => ND_9OP_1_ND_9OP_1_d1_CTRL,
		PARAM_DT => PARAM_DT,
		PARAM_LD => PARAM_LD,
		ND_9_PARAM_FIFO_FULL => ND_9_PARAM_FIFO_FULL,
		ND_9_SYNC_NUM => ND_9_SYNC_NUM,
		STOP => STOP,
		ERROR => ERROR,
		BLOCK_RD => BLOCK_RD,
		RST => RST,
		CLK => CLK
    );
  
end architecture STRUCTURE;
