-------------------------------------------------------------------------------
-- pipeline2rtl_param_ext_ip_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library compaandesign_com_pipeline2rtl_param_ext_1_lib;
use compaandesign_com_pipeline2rtl_param_ext_1_lib.all;

entity pipeline2rtl_param_ext_ip_wrapper is
  port (
    PARAM_SPLIT_X : in std_logic_vector(31 downto 0);
    COMMIT : in std_logic;
    PARAMETERS : out std_logic_vector(10 downto 0);
    PARAMETERS_LD : out std_logic;
    PCI_CLK : in std_logic;
    RST : in std_logic;
    CLK : in std_logic
  );
  
  
end pipeline2rtl_param_ext_ip_wrapper;

architecture STRUCTURE of pipeline2rtl_param_ext_ip_wrapper is

  component pipeline2rtl_param_ext is
	generic (
		RESET_HIGH : NATURAL := 1;
		QUANT : NATURAL := 32
	);
	port (
		PARAM_SPLIT_X : in std_logic_vector(31 downto 0);
		COMMIT : in std_logic;
		PARAMETERS : out std_logic_vector(10 downto 0);
		PARAMETERS_LD : out std_logic;
		PCI_CLK : in std_logic;
		RST : in std_logic;
		CLK : in std_logic
	);
end component;

begin

pipeline2rtl_param_ext_ip_wrapper_ip : pipeline2rtl_param_ext
	generic map (
		RESET_HIGH => 1,
		QUANT => 11
	)
    port map (
		PARAM_SPLIT_X => PARAM_SPLIT_X,
		COMMIT => COMMIT,
		PARAMETERS => PARAMETERS,
		PARAMETERS_LD => PARAMETERS_LD,
		PCI_CLK => PCI_CLK,
		RST => RST,
		CLK => CLK
    );
  
end architecture STRUCTURE;
